/////////////////////////////////////////////////////////////////////////////////////////////////////////
// TestPhisicalWrite.cpp : Defines the entry point for the console application.
//

#include <windows.h>
#include <stdio.h>

#include <winioctl.h>

int f2b(const char *pszFileName, unsigned char **ppbFileBuffer, long *pdwSize) {
	FILE *hFile;
	long dwSize = 0;
	*pdwSize = 0x00;
	if ((hFile = fopen(pszFileName, "rb")) == 0)
		return 1;
	*ppbFileBuffer = (unsigned char*)malloc(1024*512*sizeof(unsigned char));
	do {
		if (ppbFileBuffer == NULL)
			return 2;
		dwSize = fread(&((*ppbFileBuffer)[*pdwSize]), 1, 1024*512, hFile);
		*pdwSize += dwSize;
		*ppbFileBuffer = (unsigned char*)realloc(*ppbFileBuffer, *pdwSize + 1024*512);
	}
	while (dwSize == 1024*512);
	fclose(hFile);
	return 0;
}

int main(int argc, char* argv[]) {
	DWORD dwError = ERROR_SUCCESS;
	BYTE *filebuff;
	DWORD size;
	int iRet;
	void *lpMsgBuf;
	char name[256];
		
	if (argc < 3) {
		printf("parameters error!\r\n");
		return 0;
	}
	
	sprintf(name, "\\\\.\\%s", argv[1]);
	printf("Disk name: %s\r\n", name);

	f2b(argv[2], &filebuff, &size);
	printf("loaded %d bytes!\r\n", size);
	
	//    
	HANDLE hFile = CreateFileA(name, //  
			GENERIC_READ | GENERIC_WRITE, 
			FILE_SHARE_READ | FILE_SHARE_WRITE, 
			NULL, 
			OPEN_EXISTING, //   
			FILE_FLAG_WRITE_THROUGH | FILE_FLAG_NO_BUFFERING, //    
			NULL);
	
	DWORD dwLen = 0;
	
	//      
	printf("DeviceIoControl()\r\n");
	BOOL bRet = DeviceIoControl(hFile, FSCTL_LOCK_VOLUME, NULL, 0, NULL, 0, &dwLen, NULL);
	if(bRet) {
		int i;
		for (i = 0; i < size; i += 0x10000) {
			DWORD dwNumberOfBytesWritten = 0x10000;
			DWORD dwRet = SetFilePointer(hFile, i, 0, 0);
			if(dwRet != INVALID_SET_FILE_POINTER) {
				if (size-i < 0x10000) {
					dwNumberOfBytesWritten = size-i;
				}
				iRet = WriteFile(hFile, &filebuff[i], dwNumberOfBytesWritten, &dwNumberOfBytesWritten, 0);
				if(iRet /* && 0x10000 == dwNumberOfBytesWritten */) {
					printf("Data written successfully (%d from %d)\n", i, size);
				}
				else
				{
					printf("Data written error (%08x / %d) (%d from %d)\n", iRet, dwNumberOfBytesWritten, i, size);
				}
			} else {
				printf("SetFilePointer() failed!\r\n");
			}
		}
	}
	
	dwError = GetLastError();
	FormatMessageA( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER | 
		FORMAT_MESSAGE_FROM_SYSTEM | 
		FORMAT_MESSAGE_IGNORE_INSERTS, 
		NULL, 
		GetLastError(), 
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
		(LPSTR) &lpMsgBuf, 
		0, 
		NULL 
		);
	printf("\nError: %d %s", dwError, lpMsgBuf);
	
	return dwError;
}
